rebase: do not print lots of usage hints after an obvious error message
[git/dscho.git] / git-sh-setup.sh
blobaa16b8356507e4e669ee5c4cb4b5a667942d559e
1 #!/bin/sh
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
14 git_broken_path_fix () {
15 case ":$PATH:" in
16 *:$1:*) : ok ;;
18 PATH=$(
19 SANE_TOOL_PATH="$1"
20 IFS=: path= sep=
21 set x $PATH
22 shift
23 for elem
25 case "$SANE_TOOL_PATH:$elem" in
26 (?*:/bin | ?*:/usr/bin)
27 path="$path$sep$SANE_TOOL_PATH"
28 sep=:
29 SANE_TOOL_PATH=
30 esac
31 path="$path$sep$elem"
32 sep=:
33 done
34 echo "$path"
37 esac
40 # @@BROKEN_PATH_FIX@@
42 die() {
43 echo >&2 "$@"
44 exit 1
47 GIT_QUIET=
49 say () {
50 if test -z "$GIT_QUIET"
51 then
52 printf '%s\n' "$*"
56 if test -n "$OPTIONS_SPEC"; then
57 usage() {
58 "$0" -h
59 exit 1
62 parseopt_extra=
63 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
64 parseopt_extra="--keep-dashdash"
66 eval "$(
67 echo "$OPTIONS_SPEC" |
68 git rev-parse --parseopt $parseopt_extra -- "$@" ||
69 echo exit $?
71 else
72 dashless=$(basename "$0" | sed -e 's/-/ /')
73 usage() {
74 die "Usage: $dashless $USAGE"
77 if [ -z "$LONG_USAGE" ]
78 then
79 LONG_USAGE="Usage: $dashless $USAGE"
80 else
81 LONG_USAGE="Usage: $dashless $USAGE
83 $LONG_USAGE"
86 case "$1" in
87 -h|--h|--he|--hel|--help)
88 echo "$LONG_USAGE"
89 exit
90 esac
93 set_reflog_action() {
94 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
95 then
96 GIT_REFLOG_ACTION="$*"
97 export GIT_REFLOG_ACTION
101 git_editor() {
102 if test -z "${GIT_EDITOR:+set}"
103 then
104 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
107 eval "$GIT_EDITOR" '"$@"'
110 git_pager() {
111 if test -t 1
112 then
113 GIT_PAGER=$(git var GIT_PAGER)
114 else
115 GIT_PAGER=cat
117 : ${LESS=-FRSX}
118 export LESS
120 eval "$GIT_PAGER" '"$@"'
123 sane_grep () {
124 GREP_OPTIONS= LC_ALL=C grep "$@"
127 sane_egrep () {
128 GREP_OPTIONS= LC_ALL=C egrep "$@"
131 is_bare_repository () {
132 git rev-parse --is-bare-repository
135 cd_to_toplevel () {
136 cdup=$(git rev-parse --show-toplevel) &&
137 cd "$cdup" || {
138 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
139 exit 1
143 require_work_tree () {
144 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
145 die "fatal: $0 cannot be used without a working tree."
148 require_clean_work_tree () {
149 git rev-parse --verify HEAD >/dev/null || exit 1
150 git update-index -q --ignore-submodules --refresh
151 err=0
153 if ! git diff-files --quiet --ignore-submodules
154 then
155 echo >&2 "Cannot $1: You have unstaged changes."
156 err=1
159 if ! git diff-index --cached --quiet --ignore-submodules HEAD --
160 then
161 if [ $err = 0 ]
162 then
163 echo >&2 "Cannot $1: Your index contains uncommitted changes."
164 else
165 echo >&2 "Additionally, your index contains uncommitted changes."
167 err=1
170 if [ $err = 1 ]
171 then
172 test -n "$2" && echo >&2 "$2"
173 exit 1
177 get_author_ident_from_commit () {
178 pick_author_script='
179 /^author /{
180 s/'\''/'\''\\'\'\''/g
182 s/^author \([^<]*\) <[^>]*> .*$/\1/
183 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
186 s/^author [^<]* <\([^>]*\)> .*$/\1/
187 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
190 s/^author [^<]* <[^>]*> \(.*\)$/\1/
191 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
196 encoding=$(git config i18n.commitencoding || echo UTF-8)
197 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
198 LANG=C LC_ALL=C sed -ne "$pick_author_script"
201 # Clear repo-local GIT_* environment variables. Useful when switching to
202 # another repository (e.g. when entering a submodule). See also the env
203 # list in git_connect()
204 clear_local_git_env() {
205 unset $(git rev-parse --local-env-vars)
208 # Make sure we are in a valid repository of a vintage we understand,
209 # if we require to be in a git repository.
210 if test -z "$NONGIT_OK"
211 then
212 GIT_DIR=$(git rev-parse --git-dir) || exit
213 if [ -z "$SUBDIRECTORY_OK" ]
214 then
215 test -z "$(git rev-parse --show-cdup)" || {
216 exit=$?
217 echo >&2 "You need to run this command from the toplevel of the working tree."
218 exit $exit
221 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
222 echo >&2 "Unable to determine absolute path of git directory"
223 exit 1
225 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
228 # Fix some commands on Windows
229 case $(uname -s) in
230 *MINGW*)
231 # Windows has its own (incompatible) sort and find
232 sort () {
233 /usr/bin/sort "$@"
235 find () {
236 /usr/bin/find "$@"
238 is_absolute_path () {
239 case "$1" in
240 [/\\]* | [A-Za-z]:*)
241 return 0 ;;
242 esac
243 return 1
247 is_absolute_path () {
248 case "$1" in
250 return 0 ;;
251 esac
252 return 1
254 esac